#! /usr/bin/python 
from FLTKDescriptor import *
widget0 =FLTKDescriptor("namespace fltk {","TextSelection {","(null)");
widget0.PublicInstanceMethods.append("    void set(int start, int end)");
widget0.PublicInstanceMethods.append("    void set_rectangular(int start, int end, int rectStart, int rectEnd)");
widget0.PublicInstanceMethods.append("    void update(int pos, int nDeleted, int nInserted)");
widget0.PublicInstanceMethods.append("    char rectangular() ");
widget0.PublicInstanceMethods.append("    int start() ");
widget0.PublicInstanceMethods.append("    int end() ");
widget0.PublicInstanceMethods.append("    int rect_start() ");
widget0.PublicInstanceMethods.append("    int rect_end() ");
widget0.PublicInstanceMethods.append("    char selected() ");
widget0.PublicInstanceMethods.append("    void selected(char b) ");
widget0.PublicInstanceMethods.append("    int includes(int pos, int lineStartPos, int dispIndex)");
widget0.PublicInstanceMethods.append("    int position(int* start, int* end)");
widget0.PublicInstanceMethods.append("    int position(int* start, int* end, int* isRect, int* rectStart, int* rectEnd)");
print widget0;
widget0.generate();
#! /usr/bin/python 
from FLTKDescriptor import *
widget1 =FLTKDescriptor("namespace fltk {","TextBuffer {","(null)");
widget1.PublicInstanceMethods.append("    TextBuffer(int requestedSize = 0)");
widget1.PublicInstanceMethods.append("    int length() ");
widget1.PublicInstanceMethods.append("    const char* text()");
widget1.PublicInstanceMethods.append("    void text(const char* text)");
widget1.PublicInstanceMethods.append("    const char* text_range(int start, int end)");
widget1.PublicInstanceMethods.append("    char character(int pos)");
widget1.PublicInstanceMethods.append("    const char* text_in_rectangle(int start, int end, int rectStart, int rectEnd)");
widget1.PublicInstanceMethods.append("    void insert(int pos, const char* text)");
widget1.PublicInstanceMethods.append("    void append(const char* text) ");
widget1.PublicInstanceMethods.append("    void remove(int start, int end)");
widget1.PublicInstanceMethods.append("    void replace(int start, int end, const char *text)");
widget1.PublicInstanceMethods.append("    void copy(TextBuffer* fromBuf, int fromStart, int fromEnd, int toPos)");
widget1.PublicInstanceMethods.append("    int insertfile(const char *file, int pos, int buflen = 128*1024)");
widget1.PublicInstanceMethods.append("    int appendfile(const char *file, int buflen = 128*1024)");
widget1.PublicInstanceMethods.append("    int loadfile(const char *file, int buflen = 128*1024)");
widget1.PublicInstanceMethods.append("    int outputfile(const char *file, int start, int end, int buflen = 128*1024)");
widget1.PublicInstanceMethods.append("    int savefile(const char *file, int buflen = 128*1024)");
widget1.PublicInstanceMethods.append("    void insert_column(int column, int startPos, const char* text,                        int* charsInserted, int* charsDeleted)");
widget1.PublicInstanceMethods.append("    void replace_rectangular(int start, int end, int rectStart, int rectEnd,                              const char* text)");
widget1.PublicInstanceMethods.append("    void overlay_rectangular(int startPos, int rectStart, int rectEnd,                              const char* text, int* charsInserted,                              int* charsDeleted)");
widget1.PublicInstanceMethods.append("    void remove_rectangular(int start, int end, int rectStart, int rectEnd)");
widget1.PublicInstanceMethods.append("    void clear_rectangular(int start, int end, int rectStart, int rectEnd)");
widget1.PublicInstanceMethods.append("    int tab_distance() ");
widget1.PublicInstanceMethods.append("    void tab_distance(int tabDist)");
widget1.PublicInstanceMethods.append("    void select(int start, int end)");
widget1.PublicInstanceMethods.append("    int selected() ");
widget1.PublicInstanceMethods.append("    void unselect()");
widget1.PublicInstanceMethods.append("    void select_rectangular(int start, int end, int rectStart, int rectEnd)");
widget1.PublicInstanceMethods.append("    int selection_position(int* start, int* end)");
widget1.PublicInstanceMethods.append("    int selection_position(int* start, int* end, int* isRect, int* rectStart,                            int* rectEnd)");
widget1.PublicInstanceMethods.append("    const char* selection_text()");
widget1.PublicInstanceMethods.append("    void remove_selection()");
widget1.PublicInstanceMethods.append("    void replace_selection(const char* text)");
widget1.PublicInstanceMethods.append("    void secondary_select(int start, int end)");
widget1.PublicInstanceMethods.append("    void secondary_unselect()");
widget1.PublicInstanceMethods.append("    void secondary_select_rectangular(int start, int end, int rectStart,                                       int rectEnd)");
widget1.PublicInstanceMethods.append("    int secondary_selection_position(int* start, int* end, int* isRect,                                      int* rectStart, int* rectEnd)");
widget1.PublicInstanceMethods.append("    const char* secondary_selection_text()");
widget1.PublicInstanceMethods.append("    void remove_secondary_selection()");
widget1.PublicInstanceMethods.append("    void replace_secondary_selection(const char* text)");
widget1.PublicInstanceMethods.append("    void highlight(int start, int end)");
widget1.PublicInstanceMethods.append("    void unhighlight()");
widget1.PublicInstanceMethods.append("    void highlight_rectangular(int start, int end, int rectStart, int rectEnd)");
widget1.PublicInstanceMethods.append("    int highlight_position(int* start, int* end, int* isRect, int* rectStart,                            int* rectEnd)");
widget1.PublicInstanceMethods.append("    const char* highlight_text()");
widget1.PublicInstanceMethods.append("    void add_modify_callback(TextModifyCb bufModifiedCB, void* cbArg)");
widget1.PublicInstanceMethods.append("    void remove_modify_callback(TextModifyCb bufModifiedCB, void* cbArg)");
widget1.PublicInstanceMethods.append("    void call_modify_callbacks() ");
widget1.PublicInstanceMethods.append("    const char* line_text(int pos)");
widget1.PublicInstanceMethods.append("    int line_start(int pos)");
widget1.PublicInstanceMethods.append("    int line_end(int pos)");
widget1.PublicInstanceMethods.append("    int word_start(int pos)");
widget1.PublicInstanceMethods.append("    int word_end(int pos)");
widget1.PublicInstanceMethods.append("    int expand_character(int pos, int indent, char *outStr)");
widget1.PublicStaticMethods.append("    static int expand_character(char c, int indent, char* outStr, int tabDist,                                 char nullSubsChar)");
widget1.PublicStaticMethods.append("    static int character_width(char c, int indent, int tabDist, char nullSubsChar)");
widget1.PublicInstanceMethods.append("    int count_displayed_characters(int lineStartPos, int targetPos)");
widget1.PublicInstanceMethods.append("    int skip_displayed_characters(int lineStartPos, int nChars)");
widget1.PublicInstanceMethods.append("    int count_lines(int startPos, int endPos)");
widget1.PublicInstanceMethods.append("    int skip_lines(int startPos, int nLines)");
widget1.PublicInstanceMethods.append("    int rewind_lines(int startPos, int nLines)");
widget1.PublicInstanceMethods.append("    int findchar_forward(int startPos, char searchChar, int* foundPos)");
widget1.PublicInstanceMethods.append("    int findchar_backward(int startPos, char searchChar, int* foundPos)");
widget1.PublicInstanceMethods.append("    int findchars_forward(int startPos, const char* searchChars, int* foundPos)");
widget1.PublicInstanceMethods.append("    int findchars_backward(int startPos, const char* searchChars, int* foundPos)");
widget1.PublicInstanceMethods.append("    int search_forward(int startPos, const char* searchString, int* foundPos,                        int matchCase = 0)");
widget1.PublicInstanceMethods.append("    int search_backward(int startPos, const char* searchString, int* foundPos,                         int matchCase = 0)");
widget1.PublicInstanceMethods.append("    int substitute_null_characters(char* string, int length)");
widget1.PublicInstanceMethods.append("    void unsubstitute_null_characters(char* string)");
widget1.PublicInstanceMethods.append("    char null_substitution_character() ");
widget1.PublicInstanceMethods.append("    TextSelection* primary_selection() ");
widget1.PublicInstanceMethods.append("    TextSelection* secondary_selection() ");
widget1.PublicInstanceMethods.append("    TextSelection* highlight_selection() ");
widget1.PublicInstanceMethods.append("    void call_modify_callbacks(int pos, int nDeleted, int nInserted,                                int nRestyled, const char* deletedText)");
widget1.PublicInstanceMethods.append("    int insert_(int pos, const char* text)");
widget1.PublicInstanceMethods.append("    void remove_(int start, int end)");
widget1.PublicInstanceMethods.append("    void remove_rectangular_(int start, int end, int rectStart, int rectEnd,                              int* replaceLen, int* endPos)");
widget1.PublicInstanceMethods.append("    void insert_column_(int column, int startPos, const char* insText,                         int* nDeleted, int* nInserted, int* endPos)");
widget1.PublicInstanceMethods.append("    void overlay_rectangular_(int startPos, int rectStart, int rectEnd,                               const char* insText, int* nDeleted,                               int* nInserted, int* endPos)");
widget1.PublicInstanceMethods.append("    void redisplay_selection(TextSelection* oldSelection,                              TextSelection* newSelection)");
widget1.PublicInstanceMethods.append("    void move_gap(int pos)");
widget1.PublicInstanceMethods.append("    void reallocate_with_gap(int newGapStart, int newGapLen)");
widget1.PublicInstanceMethods.append("    const char* selection_text(TextSelection* sel)");
widget1.PublicInstanceMethods.append("    void remove_selection_(TextSelection* sel)");
widget1.PublicInstanceMethods.append("    void replace_selection_(TextSelection* sel, const char* text)");
widget1.PublicInstanceMethods.append("    void rectangular_selection_boundaries(int lineStartPos, int rectStart,                                           int rectEnd, int* selStart,                                           int* selEnd)");
widget1.PublicInstanceMethods.append("    void update_selections(int pos, int nDeleted, int nInserted)");
widget1.Enumerators.append([
		["      "],
		["      "],
		["      "],
		["  protected"],
		["    TextSelection mPrimary"],
		["    TextSelection mSecondary"],
		["    TextSelection mHighlight"],
		["    int mLength"],
		["    char"],
		["    int mGapStart"],
		["    int mGapEnd"],
		["    int mTabDist"],
		["    int mUseTabs"],
		["    int mNModifyProcs"],
		["    TextModifyCb"],
		["    mNodifyProcs"],
		["    void"],
		["    int mCursorPosHint"],
		["    char mNullSubsChar"],
		]);
print widget1;
widget1.generate();
