#! /usr/bin/python 
from FLTKDescriptor import *
widget0 =FLTKDescriptor("namespace fltk {","TextDisplay: public Group {",": public Group {");
widget0.PublicInstanceMethods.append("    typedef void (*UnfinishedStyleCb)");
widget0.PublicInstanceMethods.append("    TextDisplay(int X, int Y, int W, int H, const char *l = 0)");
widget0.PublicInstanceMethods.append("    virtual int handle(int e)");
widget0.PublicInstanceMethods.append("    void drag_me(int pos)");
widget0.PublicInstanceMethods.append("    void buffer(TextBuffer* buf)");
widget0.PublicInstanceMethods.append("    void buffer(TextBuffer& buf) ");
widget0.PublicInstanceMethods.append("    TextBuffer* buffer() ");
widget0.PublicInstanceMethods.append("    void redisplay_range(int start, int end)");
widget0.PublicInstanceMethods.append("    void scroll(int topLineNum, int horizOffset)");
widget0.PublicInstanceMethods.append("    void insert(const char* text)");
widget0.PublicInstanceMethods.append("    void overstrike(const char* text)");
widget0.PublicInstanceMethods.append("    void insert_position(int newPos)");
widget0.PublicInstanceMethods.append("    int insert_position() ");
widget0.PublicInstanceMethods.append("    int in_selection(int x, int y)");
widget0.PublicInstanceMethods.append("    void show_insert_position()");
widget0.PublicInstanceMethods.append("    int move_right()");
widget0.PublicInstanceMethods.append("    int move_left()");
widget0.PublicInstanceMethods.append("    int move_up()");
widget0.PublicInstanceMethods.append("    int move_down()");
widget0.PublicInstanceMethods.append("    void next_word(void)");
widget0.PublicInstanceMethods.append("    void previous_word(void)");
widget0.PublicInstanceMethods.append("    void show_cursor(int b = 1)");
widget0.PublicInstanceMethods.append("    void hide_cursor() ");
widget0.PublicInstanceMethods.append("    void cursor_style(int style)");
widget0.PublicInstanceMethods.append("    int word_start(int pos) ");
widget0.PublicInstanceMethods.append("    int word_end(int pos) ");
widget0.PublicInstanceMethods.append("    void highlight_data(TextBuffer *styleBuffer,                         StyleTableEntry *styleTable,                         int nStyles, char unfinishedStyle,                         UnfinishedStyleCb unfinishedHighlightCB,                         void *cbArg)");
widget0.PublicInstanceMethods.append("    int position_style(int lineStartPos, int lineLen, int lineIndex,                        int dispIndex)");
widget0.PublicInstanceMethods.append("    virtual void layout()");
widget0.PublicInstanceMethods.append("    virtual void draw()");
widget0.PublicInstanceMethods.append("    void draw_text(const Rectangle&)");
widget0.PublicInstanceMethods.append("    void draw_range(int start, int end)");
widget0.PublicInstanceMethods.append("    void draw_cursor(int, int)");
widget0.PublicInstanceMethods.append("    void draw_string(int style, int x, int y, int toX, const char *string,                      int nChars)");
widget0.PublicInstanceMethods.append("    void draw_vline(int visLineNum, int leftClip, int rightClip,                     int leftCharIndex, int rightCharIndex)");
widget0.PublicInstanceMethods.append("    void clear_rect(int style, const Rectangle&)");
widget0.PublicInstanceMethods.append("    void display_insert()");
widget0.PublicInstanceMethods.append("    void offset_line_starts(int newTopLineNum)");
widget0.PublicInstanceMethods.append("    void calc_line_starts(int startLine, int endLine)");
widget0.PublicInstanceMethods.append("    void update_line_starts(int pos, int charsInserted, int charsDeleted,                             int linesInserted, int linesDeleted, int *scrolled)");
widget0.PublicInstanceMethods.append("    void calc_last_char()");
widget0.PublicInstanceMethods.append("    int position_to_line( int pos, int* lineNum )");
widget0.PublicInstanceMethods.append("    int string_width(const char* string, int length, int style)");
widget0.PublicStaticMethods.append("    static void buffer_modified_cb(int pos, int nInserted, int nDeleted,                                    int nRestyled, const char* deletedText,                                    void* cbArg)");
widget0.PublicStaticMethods.append("    static void h_scrollbar_cb(Scrollbar* w, TextDisplay* d)");
widget0.PublicStaticMethods.append("    static void v_scrollbar_cb( Scrollbar* w, TextDisplay* d)");
widget0.PublicInstanceMethods.append("    void update_v_scrollbar()");
widget0.PublicInstanceMethods.append("    void update_h_scrollbar()");
widget0.PublicInstanceMethods.append("    int measure_vline(int visLineNum)");
widget0.PublicInstanceMethods.append("    int longest_vline()");
widget0.PublicInstanceMethods.append("    int empty_vlines()");
widget0.PublicInstanceMethods.append("    int vline_length(int visLineNum)");
widget0.PublicInstanceMethods.append("    int xy_to_position(int x, int y, int PosType = CHARACTER_POS)");
widget0.PublicInstanceMethods.append("    void xy_to_rowcol(int x, int y, int* row, int* column,                       int PosType = CHARACTER_POS)");
widget0.PublicInstanceMethods.append("    int position_to_xy(int pos, int* x, int* y)");
widget0.PublicInstanceMethods.append("    int position_to_linecol(int pos, int* lineNum, int* column)");
widget0.PublicInstanceMethods.append("    void scroll_(int topLineNum, int horizOffset)");
widget0.PublicInstanceMethods.append("    void extend_range_for_styles(int* start, int* end)");
widget0.Enumerators.append([
		["      NORMAL_CURSOR, CARET_CURSOR, DIM_CURSOR,"],
		["      BLOCK_CURSOR, HEAVY_CURSOR"],
		]);
widget0.Enumerators.append([
		["      CURSOR_POS, CHARACTER_POS"],
		]);
widget0.Enumerators.append([
		["      DRAG_CHAR = 0, DRAG_WORD "],
		]);
print widget0;
widget0.generate();
